program derivadas

use portlib

implicit none

integer :: i   ! nmero da aproximao de cada delta
integer :: L   ! nmero de refinos de hmax
integer :: ver ! auxlio de System
integer :: tipo_funcao ! tipo de funo a derivar

real*8  :: hmax  ! maior delta 
real*8  :: r     ! razo de refino dos deltas
real*8  :: X     ! coordenada para calcular a derivada
real*8  :: exato ! soluo analtica da derivada

call dados ! l os dados do programa

open(6,file="saida19a.txt") ! 

write(6,10)
10 format("#", t5,"h", t20,"E(UDS)", t35,"E(DDS)", t50,"E(CDS-2)", t65,"E(CDS-4)")

select case ( tipo_funcao )
  case ( 1 )
     call exponencial
  case ( 2 )
     call potencia
end select

close(6)

ver = system ("Notepad saida19a.txt")

call grafico

!-------------------------------------------------

contains

!-------------------------------------------------

subroutine dados

  ver = system ("Notepad dados19a.txt")

  open(5,file="dados19a.txt")
  read(5,*) tipo_funcao
  read(5,*) hmax
  read(5,*) r
  read(5,*) L
  read(5,*) X
  close(5)

end subroutine dados

!-------------------------------------------------

subroutine exponencial

  real*8 :: xw,  h,   fp,  fw,  fl_UDS, fl_DDS, xe, fe, fl_CDS2, &
            xww, xee, fww, fee, fl_CDS4

  ! calcula a derivada da exponencial de X

  exato = dexp(X)

  do i = 0, L

     h = hmax / ( r ** i )

     xw  = X - h
     xe  = X + h
     xww = X - 2*h
     xee = X + 2*h

     fp  = dexp(x)
     fw  = dexp(xw)
     fe  = dexp(xe)
     fww = dexp(xww)
     fee = dexp(xee)

     fl_UDS  = ( fp - fw ) / h
     fl_DDS  = ( fe - fp ) / h
     fl_CDS2 = ( fe - fw ) / (2 * h)
     fl_CDS4 = ( 8*fe - 8*fw + fww - fee ) / (12 * h)

     write(6,10) h, dabs(exato-fl_UDS),  dabs(exato-fl_DDS), &
                    dabs(exato-fl_CDS2), dabs(exato-fl_CDS4)
     10 format( 5(1pe15.5) )

  end do

end subroutine exponencial

!-------------------------------------------------

subroutine potencia

  real*8 :: xw,  h,   fp,  fw,  fl_UDS, fl_DDS, xe, fe, fl_CDS2, &
            xww, xee, fww, fee, fl_CDS4

  ! calcula a derivada de X**5

  exato = 5*X**4

  do i = 0, L

     h = hmax / ( r ** i )

     xw  = X - h
     xe  = X + h
     xww = X - 2*h
     xee = X + 2*h

     fp  = x**5
     fw  = xw**5
     fe  = xe**5
     fww = xww**5
     fee = xee**5

     fl_UDS  = ( fp - fw ) / h
     fl_DDS  = ( fe - fp ) / h
     fl_CDS2 = ( fe - fw ) / (2 * h)
     fl_CDS4 = ( 8*fe - 8*fw + fww - fee ) / (12 * h)

     write(6,10) h, dabs(exato-fl_UDS),  dabs(exato-fl_DDS), &
                    dabs(exato-fl_CDS2), dabs(exato-fl_CDS4)
     10 format( 5(1pe15.5) )

  end do

end subroutine potencia

!-------------------------------------------------

subroutine grafico

  integer k

  open(9,file="comandos19a.gnu")
  do k = 1, 12
     read(9,*)
  end do

  select case ( tipo_funcao )
     case ( 1 )
        write(9,*) "set title 'derivada de exponencial(X)'"
     case ( 2 )
        write(9,*) "set title 'derivada de X**5'"
  end select

  write(9,*) "replot"

  close(9)

  ver = system ("Wgnuplot comandos19a.gnu")

end subroutine grafico

!-------------------------------------------------

end program derivadas
