program integrais

use portlib

implicit none

integer :: i    ! nmero do refino dos elementos de integrao
integer :: j    ! nmero do elemento de integrao
integer :: Nmin ! nmero mnimo de elementos de integrao
integer :: L    ! nmero de refinos de elementos de integrao
integer :: r    ! razo de aumento de elementos de integrao
integer :: ver  ! auxlio de System
integer :: tipo_funcao ! tipo de funo a derivar

real*8  :: h     ! tamanho dos elementos de integrao
real*8  :: exato ! soluo analtica da derivada

call dados ! l os dados do programa

open(6,file="saida19b.txt") ! 

write(6,10)
10 format("#", t5,"h", t20,"E(retngulo)", t35,"E(trapzio)", t50,"E(simpson)")

select case ( tipo_funcao )
  case ( 1 )
     call exponencial
  case ( 2 )
     call potencia
end select

close(6)

ver = system ("Notepad saida19b.txt")

call grafico

!-------------------------------------------------

contains

!-------------------------------------------------

subroutine dados

  ver = system ("Notepad dados19b.txt")

  open(5,file="dados19b.txt")
  read(5,*) tipo_funcao
  read(5,*) Nmin
  read(5,*) r
  read(5,*) L
  close(5)

end subroutine dados

!-------------------------------------------------

subroutine exponencial

  real*8 :: xp, fp, ret, trap, xw, fw, simp, xe, fe

  ! calcula a integral da exponencial de X entre 0 e 1

  exato = dexp(1.0d0) - 1

  do i = 0, L

     h = 1.0d0 / ( Nmin * (r ** i) )

     ret  = 0.0d0
     trap = 0.0d0

     do j = 1, Nmin*(r**i)

        xp = h*(j-0.5d0)
        fp = dexp(xp)
        ret = ret + fp * h

        xp = h*j
        xw = xp - h
        fw = dexp(xw)
        fp = dexp(xp)
        trap = trap + h*(fw+fp)/2

     end do

     simp = 0.0d0

     do j = 2, Nmin*(r**i), 2

        xp = h*(j-1)
        xw = xp - h
        xe = xp + h
        fw = dexp(xw)
        fe = dexp(xe)
        fp = dexp(xp)
        simp = simp + h*(fw+4*fp+fe)/3

     end do

     write(6,10) h, dabs(exato-ret), dabs(exato-trap), dabs(exato-simp)

     10 format( 4(1pe15.5) )

  end do

end subroutine exponencial

!-------------------------------------------------

subroutine potencia

  real*8 :: xp, fp, ret, trap, xw, fw, simp, xe, fe

  ! calcula a integral de X**5 entre 0 e 1

  exato = 1 / 6.0d0

  do i = 0, L

     h = 1.0d0 / ( Nmin * (r ** i) )

     ret  = 0.0d0
     trap = 0.0d0

     do j = 1, Nmin*(r**i)

        xp = h*(j-0.5d0)
        fp = xp**5
        ret = ret + fp * h

        xp = h*j
        xw = xp - h
        fw = xw**5
        fp = xp**5
        trap = trap + h*(fw+fp)/2

     end do

     simp = 0.0d0

     do j = 2, Nmin*(r**i), 2

        xp = h*(j-1)
        xw = xp - h
        xe = xp + h
        fw = xw**5
        fe = xe**5
        fp = xp**5
        simp = simp + h*(fw+4*fp+fe)/3

     end do

     write(6,10) h, dabs(exato-ret), dabs(exato-trap), dabs(exato-simp)

     10 format( 4(1pe15.5) )

  end do

end subroutine potencia

!-------------------------------------------------

subroutine grafico

  integer k

  open(9,file="comandos19b.gnu")
  do k = 1, 11
     read(9,*)
  end do

  select case ( tipo_funcao )
     case ( 1 )
        write(9,*) "set title 'integral de exponencial(X) entre 0 e 1'"
     case ( 2 )
        write(9,*) "set title 'integral de X**5 entre 0 e 1'"
  end select

  write(9,*) "replot"

  close(9)

  ver = system ("Wgnuplot comandos19b.gnu")

end subroutine grafico

!-------------------------------------------------

end program integrais
